Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/BaseExportShapeOptions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/BaseExportShapeOptions.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/BaseExportShapeOptions.java	(revision 43920)
@@ -0,0 +1,42 @@
+/*
+ * To change this license header, choose License Headers in Project Properties.
+ * To change this template file, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package org.gvsig.exportto.swing.prov.shape;
+
+import java.io.File;
+import org.gvsig.exportto.swing.spi.options.BaseExportGeometryOptions;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class BaseExportShapeOptions 
+        extends BaseExportGeometryOptions
+        implements ExportShapeOptions
+    {
+    private String encoding;
+    private File file;
+
+    @Override
+    public String getEncoding() {
+        return this.encoding;
+    }
+
+    @Override
+    public void setEncoding(String encoding) {
+        this.encoding = encoding;
+    }
+
+    @Override
+    public File getFile() {
+        return this.file;
+    }
+
+    @Override
+    public void setFile(File file) {
+        this.file = file;
+    }
+        
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExportShapeOptions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExportShapeOptions.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExportShapeOptions.java	(revision 43920)
@@ -0,0 +1,12 @@
+package org.gvsig.exportto.swing.prov.shape;
+
+import org.gvsig.exportto.swing.prov.dbf.ExportDBFOptions;
+import org.gvsig.exportto.swing.spi.options.ExportGeometryOptions;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public interface ExportShapeOptions extends ExportDBFOptions, ExportGeometryOptions {
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExporttoShapeProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExporttoShapeProvider.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExporttoShapeProvider.java	(revision 43920)
@@ -25,11 +25,13 @@
 
 import org.cresques.cts.IProjection;
 import org.gvsig.exportto.ExporttoService;
-import org.gvsig.exportto.swing.prov.dbf.ExporttoDBFService;
-import org.gvsig.exportto.swing.prov.dbf.panel.ExporttoDBFPanel;
-import org.gvsig.exportto.swing.prov.file.AbstractExporttoFileProvider;
+import org.gvsig.exportto.swing.prov.dbf.ExporttoDBFProvider;
 import org.gvsig.exportto.swing.spi.ExporttoSwingProvider;
+import org.gvsig.exportto.swing.spi.panels.CheckGeometriesPanel;
+import org.gvsig.exportto.swing.spi.panels.SelectGeometryTypePanel;
+import org.gvsig.exportto.swing.spi.panels.SelectionOfTheGeometryFieldPanel;
 import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.geom.Geometry;
 import org.gvsig.tools.service.spi.ProviderServices;
 
 /**
@@ -38,24 +40,60 @@
  * @author gvSIG Team
  * @version $Id$
  */
-public class ExporttoShapeProvider extends AbstractExporttoFileProvider
+public class ExporttoShapeProvider extends ExporttoDBFProvider
     implements ExporttoSwingProvider {
 
-    /**
-     * Constructor.
-     * 
-     * @param providerServices
-     *            the services for the provider
-     * @param file
-     *            to get the Exporto from
-     */
-    public ExporttoShapeProvider(ProviderServices providerServices,
-        FeatureStore featureStore, IProjection projection) {
-        super(providerServices, featureStore, projection, new ExporttoDBFPanel());
+    @SuppressWarnings("OverridableMethodCallInConstructor")
+    public ExporttoShapeProvider(
+        ProviderServices providerServices,
+        FeatureStore featureStore,
+        IProjection projection
+        ) {
+        super(providerServices, featureStore);
+        this.getOptions().setTargetProjection(projection);
     }
 
+    @Override
+    protected void addPanels() {
+        this.panelAdd(new SelectionOfTheGeometryFieldPanel(this.getOptions()));
+        this.panelAdd(new SelectGeometryTypePanel(
+                this.getOptions(),
+                new int[] { 
+                    Geometry.TYPES.GEOMETRY,
+                    Geometry.TYPES.POINT,
+                    Geometry.TYPES.LINE,
+                    Geometry.TYPES.POLYGON,
+                    Geometry.TYPES.MULTIPOINT,
+                    Geometry.TYPES.MULTILINE,
+                    Geometry.TYPES.MULTIPOLYGON
+                },
+                new int[] {
+                    Geometry.SUBTYPES.GEOM2D,
+                    Geometry.SUBTYPES.GEOM3D,
+                    Geometry.SUBTYPES.GEOM3DM
+                } 
+            )
+        );
+        this.panelAdd(new CheckGeometriesPanel(this.getOptions()));
+        super.addPanels(); 
+    }
+
+    @Override
+    public ExportShapeOptions getOptions() {
+        if( this.options == null ) {
+            this.options = new BaseExportShapeOptions();
+        }
+        return (ExportShapeOptions) this.options;
+    }
+    
+    @Override
     public ExporttoService createExporttoService() {
-        return new ExporttoShapeService(
-            selectFileOptionPanel, featureStore, projection, ((ExporttoDBFPanel) selectFileOptionPanel).getEncoding());
+        return new ExporttoShapeService(this.getOptions());
     }
+
+    @Override
+    public boolean needsPanelTargetProjection() {
+        return true;
+    }
+    
 }
